
var ANNEID = {};

ANNEID._masterUserArray = [];
ANNEID._loginHistory = null;
ANNEID._aon_nid = 0;
ANNEID.nickname = "";
ANNEID.bACTIVATED=false;
ANNEID.bUSERGENESIS=false;

/**
 * reinit these els each time as the DOM has destroyed them from last time.
 */
ANNEID.initAsync = async()=> {

    ANNEID._aon_nid = 0;

    var el_edit_name = document.getElementById("anneid_edit");
    el_edit_name.addEventListener("click", e=>ANNEID.edit_nickname(e));
    
    var el_savetoanne = document.getElementById("anneid_save");
    el_savetoanne.addEventListener("click", e=>ANNEID.saveGhostsToANNE(e));

    var link_na = document.getElementById('link_newaccount');
    link_na.addEventListener("click", e=>ANNEID.newAccount(e));
    var link_rb = document.getElementById('link_restorebackup');
    link_rb.addEventListener("click", e=>ANNEID.restorebackup(e));
    if(ANNE.USER._userLS.backed_up=="") link_rb.classList.add("attention");
    var link_rt = document.getElementById('link_removethis');
    link_rt.addEventListener("click", e=>ANNEID.removeThisAccount(e));

    ANNEID.bACTIVATED = ANNE.USER._userLS.activated;

    var show_config_data = document.getElementById("show_config_data");
    show_config_data.addEventListener("click", function(e) {
            if (ANNE.USER._userNObj.bes[0]==MEM.annode_identity.temp_nid || ANNE.USER._userNObj.bes[0]==ANNE.MEM.miner_identity.temp_nid) {
                var msg = "Copy this and paste it into your annode node.properties config.<BR><BR>"+ANNE.USER.genKeyPopupMsg()+"<BR><BR><BR>";
            }
            else {
                var msg = "Here is your ANNE key info.<BR><BR>"+ANNE.USER.genStandardKeyPopupMsg()+"<BR><BR><BR>";
            }
            const DNDALERT = new DNDAlert({
            title: "ANNODE config helper",
            message:msg,
            type: "info",
            html: true,
            closeBackgroundClick: true,
            portalElement: document.querySelector("body"),
            portalOverflowHidden: true,
            textAlign: "center",
            theme: "dark",
            onOpen: (bag) => {
                console.log("Modal Opened");
                console.log(bag.PROPERTIES);
            },
            onClose: (bag) => {
                console.log("Modal Closed");
                console.log(bag);
            },
            opacity: 1,
            draggable: true,
            animationStatus: true,
            closeIcon: true,
            sourceControlWarning: true,
            });
    })
    
    //if we are using multi-accts, this will be here.
    if (document.getElementById("div_acctsdd")!=null) {
        ANNE.A.empty("div_acctsdd");
        ANNE._userAccts = [];
        var defaultLbl = ANNE.USER.getBestUserAcctName(ANNE.USER._userLS, true);
        var users = await ANNE.USER.getUserArrByAEP(ANNE._annodesLS.last_uri);
        console.log(users);
        for (var u=0; u < users.length; u++) {
            var acct_name = USER.getBestUserAcctName(users[u]);
            ANNE._userAccts.push({nid:users[u].public_nid, text:acct_name, pubKey:users[u].pubKey});
            users[u].text = acct_name;
        }
        
        ANNE.A.makeHTMLDD_fromUserObjs("240px", "div_acctsdd", users, {defaultLbl:defaultLbl, cb:ANNEID.accountDDChanged});
    }

    ANNEID.populateGUI();
    ANNE.A.show("leftMainBtnMenuXX");
}


/**
 * 
 * @param {*} $nid 
 * @returns 
 */
ANNEID.pubKeyFromKnownAcct=function($nid) {
    for (var u=0; u  < ANNE._userAccts.length; u++) {
        if (ANNE._userAccts[u].nid==$nid) {
            if (ANNE._userAccts[u].pubKey!=undefined) return ANNE._userAccts[u].pubKey;
        }
    }
    return "";
}


/**
 * 
 * @param {*} $option 
 * @returns 
 */
ANNEID.accountDDChanged=async($nid)=> {
    console.log("(accountDDChanged)");
    if (USER._userNObj!=null && ANNE.USER._userNObj.nid==$nid) return; //do nothing, we are already on this account.
    ANNE.USER.loadAccount($nid);
    location.reload();
}



/**
 * @author Mr.scatman
 */
 ANNEID.populateGUI = async($bGETBALANCE=true, $bGETTXS=true)=> {
    await ANNEID._isLoggedIn();
    ANNEID._loginHistory = await ANNE.USER._getHistory();

    //check for new data (or first-time min data)
    if (USER._userNObj.bes.length==0) {
        await ANNE.API.queryForOuts(USER._userNObj.nid, true, [0,1]);
    }

    //HAS THE USER SET THEIR IDENTITY TYPE?  THIS MUST BE DONE FIRST!!!!!
    if (USER._userNObj.bes.length) {
        var beNOBJ = ANNE.MEMG.getNeuronByTempNid(ANNE.USER._userNObj.bes[0]);
        if (beNOBJ!=null && beNOBJ.text!="" && beNOBJ.temp_nid!=ANNE.MEM.identity.temp_nid) {
            return await ANNEID.classIsSet($bGETBALANCE, $bGETTXS);  
        }
    }

    ANNEID._makeIdentityDD();
}


ANNEID.makeUserLink = function($el, $nid, $pre="") {
    var el = ANNE.A.__getEl($el);
    if (el==null) {
        console.warn("missing el");
        return null;
    }
    if ($pre!="") {
        var spanpre=document.createElement("span");
        spanpre.innerHTML=$pre+"&nbsp;";
        el.append(spanpre);
    }
    var span=document.createElement("span");
    span.classList="link-anneid-user";
    span.title = "nid:"+$nid;

    const nObj = ANNE.MEMG.getOrMakeIfNew($nid);
    span.innerHTML = nObj.bestNameHTML();
    span.setAttribute("nid", $nid);

    span.addEventListener("click", e=>{
        ANNE.ANX.addNeuronIdentityBtn(nObj);
    });
    el.append(span);
    return span;
}


/**
 * 
 */
ANNEID.classIsSet=async($bGETBALANCE=true, $bGETTXS=true)=> {
    ANNEID.bUSERGENESIS = false;

    //if (ANNE.EXT_BTNS!=null) ANNE.EXT_BTNS.unlocked();
    
    ANNE.A.removeSelf("annid_class_notset");

    ANNE.A.show("annid_class_set");   //try fadeIn

    var beNOBJ = ANNE.MEMG.getNeuronByTempNid(ANNE.USER._userNObj.bes[0]);
    ANNE.A.setHTML("anneid_class_display",'<span style="font-size:.8rem; font-style:italic">identity type &nbsp;</span><b>'+beNOBJ.text+"</b>");

    var el_nid = document.getElementById("anneid_nid");
    ANNE.A.empty(el_nid);
    
    //make a user link to the left holder
    ANNEID.makeUserLink(el_nid, ANNE.USER._userNObj.nid, "<b>ANNE&#x2022;ID</b>");
        
    if ($bGETBALANCE==true) await ANNE.USER.getOurBalance();

    if ($bGETTXS==true) await ANNEID.doPaymentTransactions();
    
    //check for pending (non ghost) transaction of faucet/aon relon.
    //if (ANNE.USER._userLS.activated==false) {
      //  var rels = await ANNE.CHASE.getRelonsWithTo(ANNE.MEM.aon.nid, ANNE.USER._userNObj.nid, TO_TYPE_ANNE);
       // var real = 0;
       // for (var r=0; r < rels.length; r++) { if (rels[r].ghost==false) real+=1; }
       // if (real>0) {
          //  ANNE.USER._userNObj.bACTIVATED=true;
          //  ANNEID.bACTIVATED=true;
          //  await ANNE.USER.updateLSActivated();  
        //}
    //}

    //user is not activated yet --
    //they do not have their publicKey on the data chain yet so their acct is not
    //yet reserved...  ANNEID.anneid_activated
    if (ANNE.USER._userLS.activated==false) {
        ANNEID.bACTIVATED=false;
        console.log("%c USER IS NOT ACTIVATED YET", ANNE.TALK.bgredbig);
        ANNE.A.hide("pay");

        //*************************
        //check the ANNODE for default AON faucet.
        //hardcode just grabbing the first one found..
        //note: we have to test for the right
        //annode to use the faucet.. so the user must be set to
        //that annode.
    }

    else {
        ANNEID.bACTIVATED=true;
        console.log("%c USER IS ACTIVATED", ANNE.TALK.bggreen);
        ANNEID.assessGhostSaveToANNE();
        ANNE.A.hide("anneid_activate");
        await ANNEID.activatePay();
    }

    await ANNEID.doUserName();
}



/**
 * ???
 */
ANNEID._makeIdentityDD = function() {
    var aic = document.getElementById("anneid_identity_select_div");
    var si = ANNE.MEMG.getNeuronByNid("7777798527035018972");
    ANNEID.el_identityclassdd = ANNE.A.ezDD(aic, MEM_UDF.valid_persona_tnids, ANNEID.identity_selected, "select identity type", true, "dd-big-text", false, false, [si.temp_nid]); 
    ANNEID.el_identityclassdd.setAttribute("id", "id_anneid_dd");
    ANNE.A.addClass(ANNEID.el_identityclassdd, "border-attention-red");
    ANNE.A.fadeIn("annid_class_notset");
 }


/**
 * @author Mr.scatman
 */
 ANNEID.identity_selected = async($e)=> {
    var selected = ANNEID.el_identityclassdd.value;
    var newRelon = await USER._userNObj._makeSelfIdentity(selected, true);
    if(newRelon==null) return;
    ANNEID.assessGhostSaveToANNE();
    ANNEID.classIsSet(false, false);
}


ANNEID.assessGhostSaveToANNE=function(){
    var ghosts = 0;
    for (var r=0; r < ANNE.USER._userNObj.outs.length; r++) {
        var rel = ANNE.USER._userNObj.outs[r];
        if (rel.ghost==true) ghosts+=1;
    }
    var el = document.getElementById("anneidbgnotifier");

    if (ghosts>0) {
        el.style['background-color']="#09f";
        if (ANNEID.bACTIVATED==false) ANNE.A.hide("anneid_save");
        else {
            ANNE.A.show("anneid_save");
            ANNE.playSound("success");
        }
    }
    else {
        ANNE.A.hide("anneid_save");
        el.style['background-color']="#FEFE16";
    }
    
    if (ghosts) console.log("%c(assessGhostSaveToANNE) ghosts detected: "+ghosts, ANNE.TALK.blue);
}


/**
 */
ANNEID.doUserName = async($nickname="")=> {
    var bestusername = "";
    if ($nickname=="") bestusername = USER.getDefaultName();
    else bestusername = $nickname;
    //ANNE.A.setHTML("anneid_nickname", bestusername);
    if (bestusername!=USER._userNObj.nid) {
        var bNAMEISONCHAIN = false;
        var name_rel = ANNE.MEMG.getRelonFromWithRToType(ANNE.USER._userNObj.outs, TYPE_BE, ANNE.MEM.name.temp_nid, TO_TYPE_STRING);
        if (name_rel==null) {
            bNAMEISONCHAIN=false;
            console.log("TO DO: make ghost relon");
            console.log("TO DO: show ghost upgrade btn");
            await ANNE.USER._userNObj._makeSelfName(bestusername);
            ANNEID.assessGhostSaveToANNE();
            //ANNE.A.hide(ANNEID.el_upgradetoanndle);
            ANNE.A.show("anneid_edit");
        }
        else {
 
            //this name is a ghost!
            if (name_rel.ghost==true) {
                
                //this name is a ghost relon
                if (name_rel.to_s!=bestusername) {

                    //alter the ghost name in ghost mem.
                    //we only need one TYPE_BE ghost relon.
                    name_rel.to_s=bestusername;
                    await ANNE.GHOSTDATA.updateDBSingleGhostRelon(name_rel);
                }

                //can't save name to ANNE without being activated.
                ANNEID.assessGhostSaveToANNE();
                //ANNE.A.hide(ANNEID.el_upgradetoanndle);
                ANNE.A.show("anneid_edit");
            }

            //this is an on-ANNE-chain name relon
            else {
                bNAMEISONCHAIN=true;
                if (name_rel.to_s!=bestusername) {
                    
                    //arbor prune the name relon
                    await ANNE.USER._userNObj._makeArborPrune(name_rel.txid);

                    //make a new name relon.
                    await ANNE.USER._userNObj._makeSelfName(bestusername);

                    ANNEID.assessGhostSaveToANNE();
                    //ANNE.A.hide(ANNEID.el_upgradetoanndle);
                    ANNE.A.show("anneid_edit");
                }
                else {
                    ANNEID.assessGhostSaveToANNE();
                    //ANNE.A.show(ANNEID.el_upgradetoanndle);
                    ANNE.A.show("anneid_edit");
                }
            }
        }
    }
    
    else {
        ANNE.A.hide(ANNEID.el_upgradetoanndle);
        ANNE.A.show("anneid_edit");
    }
}


ANNEID.edit_nickname=async()=> {
    var nickname = prompt("Please enter a nickname for this identity", "");
    if (nickname==null) return;
    console.log(nickname);
    console.log(ANNEID._loginHistory);
    var byannodes = Object.keys(ANNEID._loginHistory);
    for (var k=0; k < byannodes.length; k++) {
        var annodeuri = byannodes[k];                    
        var thisOrigin = ANNEID._loginHistory[annodeuri];
        if (thisOrigin==undefined || thisOrigin==null) continue;
        var users = thisOrigin.users;
        if (users==undefined || users==null) continue;
        var user_keys = Object.keys(users); 
        var bSET=false;
        for (var u=0; u < user_keys.length; u++) {
            user_key = user_keys[u];
            if (user_key==ANNE.USER._userNObj.nid) {
                var user = users[user_key];
                var existingnick = user.nickname;
                var acctnm="";
                if (existingnick!=undefined && existingnick!=undefined && existingnick.length>0) {
                    acctnm = existingnick;
                }
                else acctnm = user_key;

                user.nickname = nickname;
                bSET=true;
                localStorage.setItem('ANNE', JSON.stringify(user));

                var dd = document.getElementById("div_acctsdd");
                var els = dd.querySelectorAll(".acct-name");
                for (var e=0; e < els.length; e++) {
                    if (els[e].innerHTML==acctnm || els[e].innerHTML==user_key) {
                        els[e].innerHTML=nickname;
                    }
                }
                
                break;
            }
        }

        if (bSET==true) break;
    }
    
    localStorage.setItem('ANNE_history', JSON.stringify(ANNEID._loginHistory));
    ANNE.USER._userLS.nickname = nickname;   //copy of this obj for this annode/app in RAM

    await ANNEID.doUserName(nickname);
}


/**
 * Clicked from ANNEID page
 */
ANNEID.saveGhostsToANNE=async($e)=>{
    ANNE.A.hide("anneid_save");
    var ghost_to_anneOBJ = new ghost_to_anne(ANNE.USER._userNObj);
    var bSKIPGLOBALS = false;
    var bAUTOHANAI = true;
    if (ANNE.SETTINGS!=null) bAUTOHANAI = ANNE.SETTINGS.bAUTOHANAI;
    await ghost_to_anneOBJ.update(ANNE.USER._userNObj, 0, bSKIPGLOBALS, bAUTOHANAI);

    //we will need retain the injected_div (we are in it now)
    ANNE.ANX.loadSenderFromNon3js();
}


/**
 * @author Mr.scatman
 */
 ANNEID.activatePay=async()=> {
    ANNE.A.show("payment_history");
    ANNE.A.show("pay");

    var btn_send = document.getElementById("btn_send");
    btn_send.addEventListener("click", async e=>{
        const el_inject2 = document.createElement("div");
        el_inject2.setAttribute("id", "ij2sub");

        var injectedDiv = document.getElementById("injected_div");

        //hide ANNEID div (don't destroy it)
        const injANNEID = document.getElementById("injected_anneid");
        ANNE.A.hide(injANNEID);

        //inject new div to hold receive
        injectedDiv.appendChild(el_inject2)

        await ANNE.MEM_UDF.loadSolo("send_funds.html", "ij2sub", "");
        SEND_FUNDS.init(null);

        var el_close = document.getElementById("sf_close");
        el_close.addEventListener("click", e=>{
            console.log("close SF");
            ANNE.A.show(injANNEID);
            el_inject2.remove();
        })

    });

    var btn_receive = document.getElementById("btn_receive");
    btn_receive.addEventListener("click", async e=>{

        const el_inject2 = document.createElement("div");
        el_inject2.setAttribute("id", "ij2sub");

        var injectedDiv = document.getElementById("injected_div");

        //hide ANNEID div (don't destroy it)
        const injANNEID = document.getElementById("injected_anneid");
        ANNE.A.hide(injANNEID);

        //inject new div to hold receive
        injectedDiv.appendChild(el_inject2)

        //load receive into new div
        await ANNE.MEM_UDF.loadSolo("receive_funds.html", "ij2sub", "");

        //basic display of receive address.
        //can do the qr code later.
        ANNE.A.setHTML("rf_nid_display", USER._userNObj.nid);
        ANNE.A.copyIco("rf_id_copy_ico", USER._userNObj.nid);
        var addr = ANNE.SIGNA.sig.Address.fromNumericId(USER._userNObj.nid);
        ANNE.A.setHTML("rf_addr_display", addr._rs);
        ANNE.A.copyIco("rf_addr_copy_ico", addr._rs);
        ANNE.A.hide("rf_qr");
        ANNE.A.hide("rf_anndle");

        var el_close = document.getElementById("rf_close");
        el_close.addEventListener("click", e=>{
            console.log("close RF");
            ANNE.A.show(injANNEID);
            el_inject2.remove();
        })
        
    });

    /*
    //not in this app, for now.
    var btn_streampay = document.getElementById("btn_streampay");  
    btn_streampay.addEventListener("click", e=>{
        console.log("stream pay fix this"); //"annkh", null, "streampay"
    });
    */
}



/** 
 * on app resize, if this is the active pgui in the PAGES obj it will get resized */
ANNEID.resize = function() {
}


/**
 * log out of the ANNE user.
 * wipe the seed.
 * we keep the history, prompt for new login
 */
ANNEID.newAccount=async($e)=>{
    $e.preventDefault();
    USER.logoutThisAccount();
}


/**
 * Restore from a file...
 * or make a backup file (to use in a later restore)
 * @author Mr.scatman
 */
ANNEID.restorebackup=async($e)=>{
    $e.preventDefault();
    const el_inject2 = document.createElement("div");
    el_inject2.setAttribute("id", "ij2sub");
    var injectedDiv = document.getElementById("injected_div");
    const injANNEID = document.getElementById("injected_anneid");
    ANNE.A.hide(injANNEID);
    injectedDiv.appendChild(el_inject2)
    await ANNE.MEM_UDF.loadSolo("restore_backup.html", "ij2sub", "");
    
    BACKUP.init();

    var el_close = document.getElementById("rb_view_close");
    el_close.addEventListener("click", e=>{
        ANNE.A.show(injANNEID);
        el_inject2.remove();
    })
}



/**
 * Nuke this account goodbye.
 * @author Mr.scatman
 */
ANNEID.removeThisAccount=async($e)=>{
    $e.preventDefault();
    console.warn("FIX THIS FOR NEW non-PAGES app")
    const el_inject2 = document.createElement("div");
    el_inject2.setAttribute("id", "ij2sub");
    var injectedDiv = document.getElementById("injected_div");
    const injANNEID = document.getElementById("injected_anneid");
    ANNE.A.hide(injANNEID);
    injectedDiv.appendChild(el_inject2)
    await ANNE.MEM_UDF.loadSolo("destroy_account.html", "ij2sub", "");
    var el_close = document.getElementById("da_view_close");
    el_close.addEventListener("click", e=>{
        ANNE.A.show(injANNEID);
        el_inject2.remove();
    })

    DESTROY_ACCOUNT.init();
}




/**
 * @author Mr.scatman
 */
ANNEID.anneid_activated=async($data)=> {
    ANNE.A.fadeOut("anneid_activate");
    
    await ANNE.UTILS.sleep(1000);
    await ANNE.USER.updateLSActivated();           //saves in browser mem that we are updated.
    
    ANNE.A.show("payment_activity");
    await ANNEID.doPaymentTransactions();   
    
    ANNE.A.removeSelf("anneid_activate");

    await ANNEID.activatePay();
}


/**
 * These will need a paginator.
 * Probably a table too.
 * Also search / filters etc.  (blah)
 * @author Mr.scatman
 */
ANNEID.doPaymentTransactions = async()=> {
    var pf = ANNE.A.empty("payment_activity");
    var tbl_cols = [
        {   neuron_link:false,
            relon_link:false,
            title:"block",
            prop:"block",
            class1:"annid-block",
            classH:"annid-block-H",
            s_prop:"block",
            s_type:"numeric"
        },
        {   neuron_link:false,
            relon_link:true,
            title:"txid",
            prop:"txid",
            class1:"annid-txid",
            classH:"annid-txid-H",
        },
        {   
            neuron_link:false,
            relon_link:false,
            title:"msg",
            prop:"msg",
            class1:"annid-msg",
            classH:"annid-msg-H",
        },
        {   neuron_link:false,
            relon_link:false,
            title:"dir",
            prop:"dir",
            class1:"annid-dir",
            classH:"annid-dir-H"
        },
        {   
            neuron_link:false,
            relon_link:false,
            title:"net",
            prop:"net",
            class1:"annid-annecoin",
            classH:"annid-annecoin-H"
        }
    ];
    
    //save this as a pref.. it takes time to load when there are alot
    var bDOSPONSORED = false;
    
    var rels = await BALANCE_FIXER.getUpdatedBalance3("anneid_availnow_balance", "anneid_availsoon_balance", bDOSPONSORED);
    var txs = [];
    var real=0;
    var lookup_txids =[];

    //sometimes we have 1000s of just-broadcast TXs and we don't need to lookthem up
    //this is for child-relons that do not get pulled in at the start of the app..
    //they get pulled in when needed.. but this will help chip away at refreshing broadcast TXs
    //so they don't show up as "pending" or "unconf".
    //When they are individuall clicked they also update.
    var lookup_max = 30; 
    for (var r=0; r<rels.length; r++) {
        var rel = rels[r];

        if (rel.temp==true) continue;   //no temps.
        if (rel.ghost==true) continue;
        
        //don't want to see these while logged in as anne.
        if (ANNE.isANNE(ANNE.USER._userNObj.nid)==true && ANNE.isANNE(rel.sponsored_by)==true) continue;
        
        //we could look this up to get new infos..
        if (rel.time==-1) { //-1 is unconfirmed (mempool)
            if (lookup_txids.indexOf(rel.txid)==-1) lookup_txids.push(rel.txid);
        }
        if (lookup_txids.length > lookup_max) break;
    }

    
    //clean up the gui (requires lookups but we are aiming for self-ANNODEs here)
    if (lookup_txids.length) {
        await ANNE.API.lookupTxids(lookup_txids);
    }

    var no_dupes_txids = [];
    
    for (var r=0; r<rels.length; r++) {
        var rel = rels[r];
        
        if (rel.temp==true) continue;   //no temps.
  
        //don't want to see these while logged in as anne.
        if (ANNE.isANNE(ANNE.USER._userNObj.nid)==true && ANNE.isANNE(rel.sponsored_by)==true) continue;
              
        if (rel.ghost==false) real+=1;
        var tx = {};
        tx.txid = rel.txid;
        tx.txmsg = "";
        if (rel.msg!=undefined && rel.msg.length>0) {
            tx.txmsg = rel.msg;
        }
        else if (rel.decrypted_msg!=undefined) tx.txmsg = rel.msg;
        
        if (rel.rorigin==RORIGIN_GHOST) {
            continue;
        }
        else if (rel.rorigin==RORIGIN_ANNODE && rel.type!=TYPE_INTERNAL_PAY) {
            continue;
        }
        
        if (no_dupes_txids.indexOf(rel.txid)!=-1) continue;
        no_dupes_txids.push(rel.txid);
        
        if (rel.time==-1) {     //unconfirmed now is -1.  0 is INCEPTIONS.
            tx.block=0;     
            tx.sort=0;
            if (rel.rorigin==RORIGIN_BROADCAST) {
                tx.block = "<span style='color:red'>unconf</span>";
                tx.sort = 100000000000;
            }

            //pending action (confirm or unconfirm)
            else if (rel.rorigin==RORIGIN_COLLAB_BROADCAST) {
                tx.block = "<span style='color:red'>pending collab</span>";
                tx.sort = 100000000000;
            }
            //else if (rel.r==MEM.aon.temp_nid) {
                //tx.block = "<span style='color:red'>unconf</span>";
                //tx.sort = 100000000000;
            //}
        }
        else {
            tx.block = rel.time;
            tx.sort = rel.time;
        }

        if (rel.annies!=undefined) tx.annies = rel.annies;
        else tx.annies=0;
        
        if (rel.f==ANNE.USER._userNObj.temp_nid) tx.dir = -1;
        else if (rel.to_type==TO_TYPE_ANNE && rel.t==ANNE.USER._userNObj.temp_nid) {
            tx.dir = 1;
        }
        else {
            tx.dir = 0;
        }
        tx.type = rel.type;
        tx.to_type = rel.to_type;
        tx.r = rel.r;
        tx.f = rel.f;
        tx.to_s = rel.to_s;
        tx.from_nid = rel.from_nid;
        txs.push(tx);
    }

    txs.sort(
        function($a,$b) {
            if ($a==undefined || $a==null || $b==undefined || $b==null) return 0;
            if ($a.sort > $b.sort) return -1;
            if ($a.sort < $b.sort) return 1;
            if ($a.r==MEM.BLOCK_WINNER.temp_nid) {
                return 1;//block reward down in set of ties
            }
            return 0;
        });

    var outbound = "<span class='text-yellow'>▶-</span>";
    var inbound = "<span class='text-green'>◀+</span>";


    var arrowDivs = function($text, $tx) { 
        var to = $tx.to_s;
        if ($tx.to_type==TO_TYPE_ANNE) {
            to = MEMG.getNeuronByNid(to);
            if (to!=null) to = to.text;
        }

        var pre = "";
        if ($tx.type==TYPE_AWARENESS) {
            pre = "[awarez] ";
        }
        return "<b>"+pre+"</b><span class='arrow-RR'>"+$text+"</span><span class='arrow-RR'>"+to+"</span>";
    }

    if (txs.length) {
        for (var t=0; t<txs.length; t++) {
            var dir ="";
            var tx = txs[t];
            var dirw = "";

            if (tx.dir==1) {
                dirw ="in";
                dir = inbound;
            }
            else if (tx.dir==-1) {
                dirw = "out";
                dir = outbound;
            } 
            else {
                dirw="out";
                dir = outbound;
                rel_sponsor=true;
            }
    
            var dispAmt = 0;

            //internal annode relon.
            if (tx.type==TYPE_INTERNAL_PAY) {
                dispAmt = ANNE.UTILS.displayAnneValue( Math.abs(tx.annies) );
                if (tx.from_nid==ANNE.MEM.___SELF___.nid && tx.r==ANNE.MEM.BLOCK_WINNER.temp_nid) {
                    tx.msg = "<b>BLOCK REWARD</b>";
                    tx.net = "<b>"+dir+dispAmt+"<span class='text-lg'>𝄐</span></b>";
                }
                else {
                    tx.msg = "internal payment from "+ANNE.MEMG.getNeuronByTempNid(tx.f).text;
                    tx.net = "<b>"+dir+dispAmt+"<span class='text-lg'>𝄐</span></b>";
                }
            }
    
            //hypergraph payment relon
            else if (tx.type==TYPE_BROADCAST_PAY) {
                dispAmt = ANNE.UTILS.displayAnneValue( Math.abs(tx.annies) );
                if (tx.dir==1) {
                    tx.msg = "transfer in";
                    if (tx.txmsg!=undefined && tx.txmsg.length>0) tx.msg = tx.msg + " (with msg) <b><em>"+ tx.txmsg+"</em></b>";
                    tx.net = "<b>"+dir+dispAmt+"<span class='text-lg'>𝄐</span></b>";
                }
                else {
                    tx.msg = "transfer out";
                    if (tx.txmsg!=undefined && tx.txmsg.length>0) tx.msg = tx.msg + " (with msg) <b><em>"+ tx.txmsg+"</em></b>";
                    tx.net = "<b>"+dir+dispAmt+"<span class='text-lg'>𝄐</span></b>";
                }
            }
    
            //hypergraph data relon
            else {
                if (tx.dir==1) {   //inbound relon to us
                    dispAmt = ANNE.UTILS.displayAnneValue( Math.abs(tx.annies) );
                    tx.msg = "annies inbound";
                    tx.net = "<b>"+dir+dispAmt+"<span class='text-lg'>𝄐</span></b>";
                }
            
                //calculate fees with algos for display.
                else if(tx.dir==-1) { //outbound relon from us
                    var relNOBJ = ANNE.MEMG.getNeuronByTempNid(tx.r);
                    if (tx.to_type==TO_TYPE_ANNE) {
                        if (relNOBJ.temp_nid==MEM.class.temp_nid) tx.msg = "new Hypergraph neuron of subclass "+ANNE.MEMG.getNeuronByNid(tx.to_s).text;
                        else if (relNOBJ.temp_nid==MEM.inst.temp_nid) tx.msg = "new Hypergraph neuron instance of "+ANNE.MEMG.getNeuronByNid(tx.to_s).text;
                        else tx.msg = "<span style='background-color:black'>"+arrowDivs(relNOBJ.text, tx)+"</span>";
                    }
                    else tx.msg = "<span style='background-color:black'>"+arrowDivs(relNOBJ.text, tx)+"</span>";
                    var annies = Math.abs(tx.annies);
                    var miner_fee = ANNE.getMinerFeeByToType(tx.to_type);
                    annies = annies + miner_fee;
                    var TTYPE = ANNE.TXB.calcTXTTYPE(tx);
                    var TXSpecificFee = ANNE.TXB.getExtraFeeByType(TTYPE, relNOBJ.nid);
                    if (TXSpecificFee!=0) annies+=TXSpecificFee;
                    tx.net =  "<b>"+dir+ANNE.UTILS.displayAnneValue(annies)+"<span class='text-lg'>𝄐</span>&nbsp;</b>";
                }
                else {
                    var relNOBJ = ANNE.MEMG.getNeuronByTempNid(tx.r);
                    if (tx.to_type==TO_TYPE_ANNE) {
                        if (relNOBJ.temp_nid==ANNE.MEM.class.temp_nid) tx.msg = "new Hypergraph neuron of subclass "+ANNE.MEMG.getNeuronByNid(tx.to_s).text;
                        else if (relNOBJ.temp_nid==MEM.inst.temp_nid) tx.msg = "new Hypergraph neuron instance of "+ANNE.MEMG.getNeuronByNid(tx.to_s).text;
                        else tx.msg = "<span style='background-color:black'>"+arrowDivs(relNOBJ.text, tx)+"</span>";
                    }
                    else tx.msg = "<span style='background-color:black'>"+arrowDivs(relNOBJ.text, tx)+"</span>";
                    var annies = Math.abs(tx.annies);
                    var miner_fee = ANNE.getMinerFeeByToType(tx.to_type);
                    annies = annies + miner_fee;
                    var TTYPE = ANNE.TXB.calcTXTTYPE(tx);
                    var TXSpecificFee = ANNE.TXB.getExtraFeeByType(TTYPE, relNOBJ.nid);
                    if (TXSpecificFee!=0) annies+=TXSpecificFee;
                    tx.net =  "<b>"+dir+ANNE.UTILS.displayAnneValue(annies)+"<span class='text-lg'>𝄐</span>&nbsp;</b>";
                }
            }

            tx.dir = dirw;
        }
    
        //if we have any _txs broadcast to ANNE as accepted,
        //we're activated.
        if (rels.length>0 && real>0) {
            if (ANNE.USER._userLS.activated==false) {
                ANNE.USER._userNObj.bACTIVATED=true;
                ANNEID.bACTIVATED=true;
                await ANNE.USER.updateLSActivated();           
            }
        }
    
        var el_txt_cnt = ANNE.A.setHTML("tx_cnt", txs.length);
        var el = document.getElementById("pay");
        var bb = el.getBoundingClientRect();
        var estimatedTableBodyTop = 90+bb.top;
        
        var tableObj = new neuron_table(null);
        tableObj.setManualCols(tbl_cols, txs);
        tableObj.buildDOMTable(pf, estimatedTableBodyTop, el_txt_cnt);    
    }
    
    else {
        pf.innerHTML="<h3>No transactions</h3>";
        var el = document.getElementById("pay");
        var bb = el.getBoundingClientRect();
        console.log(bb);
        var etbt = 80+bb.top;
        console.log("est "+etbt);
        ANNEID.calcAndSetH(etbt, pf);
    }
    return;
}


//rubes required for how this layout is.
ANNEID.calcAndSetH = function($top, $el) {
    var bh = (ANNE.A.getBottom() - parseInt($top)) - 22;
    ANNE.A.setMaxH($el, bh);
    return bh;
}



/**
 * not used anymore?
 * @author Mr.scatman
 */
ANNEID._getUserByAddressAndAnnode = async ($address, $annodeUri)=> {
    var users = ANNEID._loginHistory[$annodeUri];
    if (users!=undefined) {
        var user = users.user[$address];
        if (user!=undefined) return user;
        else return null;
    }
    return null;
}




/**
 * @author Mr.scatman
 */
ANNEID.displayBalance=function($index, $annies) {
    ANNE.A.empty("bal_"+$index);
    ANNE.GUI_STUFF.formatMultiTotal("bal_"+$index, "", $annies);
}



/** 
 * Is there a current user in local storage?
 * @author {Mr.Scatman}
 */
ANNEID._isLoggedIn = async()=> {
    var user = null;
    var temp = localStorage.getItem('ANNE_scope');
    var bDEAD = false;
    var ANNE_LS = null;
    var user = null;

    //if we have a local object, but it is bad, set bDEAD to true.
    if (temp!=undefined && temp!=null) {
        var ANNE_LS = JSON.parse(temp);
        if (ANNE_LS==undefined || ANNE_LS==null) bDEAD=true
        else {
            user = ANNE_LS.user;
            if (user==undefined || user==null || user.public_nid=="") bDEAD=true;
        }
    }

    //no local object, or dead was true
    if (temp==undefined || temp==null || bDEAD==true) {
        return false;   
    }

    ANNEID._user = user;
    return true;
}



var BALANCE_FIXER = {};
ANNEID.BALANCE_FIXER = BALANCE_FIXER;


/**
 * Confirmed balance is easy but unconfirmed balance is NOT.
 * The payoff to get it right is not worth the load due to all the potential
 * rev stream types in ANNE.  DO the best we can with as little of resource effort.
 * We can look for direct payment relons and not worry about the unconfirmed micro-txs.
 * @param {*} $el_avail_now 
 * @param {*} $el_avail_soon 
 * @returns 
 */
BALANCE_FIXER.getUpdatedBalance3 = async($el_avail_now, $el_avail_soon, $bDOSPONSORED=false)=> {
    $el_avail_now = ANNE.A.__getEl($el_avail_now);
    $el_avail_soon = ANNE.A.__getEl($el_avail_soon);

    if (ANNE.UTILS.isset(ANNE.USER._userNObj.balanceObj)==false) {
        var balanceObj = {annies:0, annecoin:0};
        ANNE.USER._userNObj.balanceObj = balanceObj;
    }
    var BALANCE_AUDIT = ANNE.USER._userNObj.balanceObj.annies;

    var rels = await ANNE.CHASE.getAllUserTransactions3(ANNE.USER._userNObj.nid, $bDOSPONSORED);
    var net_chg = 0;
    var net_downs = 0;
    var final_rels = [];

    var no_dupe_txids = [];
    //ANNE.TALK.printRelons(rels);

    for (var r=0; r < rels.length; r++) {
        var rel = rels[r];
        if (rel.time==0) continue;
        
        //even if documented as relon_sponsor, we didn't pay outright for this created relon
        if (rel.rorogin==RORIGIN_ANNODE && rel.type!=TYPE_INTERNAL_PAY) continue;  

        if (no_dupe_txids.indexOf(rel.txid)!=-1) continue;
        no_dupe_txids.push(rel.txid);
        
        if (rel.time==-1 && rel.rorigin==RORIGIN_BROADCAST) {
            if (rel.f==ANNE.USER._userNObj.temp_nid) {
                var miner_fee = ANNE.getMinerFeeByToType(rel.to_type);
                if (miner_fee!=0) miner_fee = parseInt(miner_fee)/ANNE.ANNE_TO_ANNIES;
                var annies = parseInt(rel.annies);
                annies = annies + miner_fee;
                var TTYPE = ANNE.TXB.calcTXTTYPE(rel);
                var relNOBJ = ANNE.MEMG.getNeuronByTempNid(rel.r);
                var TXSpecificFee = ANNE.TXB.getExtraFeeByType(TTYPE, relNOBJ.nid);
                if (TXSpecificFee!=0) annies+=parseInt(TXSpecificFee)/ANNE.ANNE_TO_ANNIES;
                net_chg -= annies;
            }
            else if (rel.t==ANNE.USER._userNObj.temp_nid) {
                net_chg += parseInt(rel.annies);
            }
        }

        final_rels.push(rel);
    }

    var unconfirmed_delta = parseInt(net_chg);
    ANNE.USER._userNObj.balanceObj.pending = parseInt(unconfirmed_delta);

    var available_now = parseInt(ANNE.USER._userNObj.balanceObj.annies) - parseInt(net_downs);
    
    ANNE.USER._userNObj.balanceObj.avail_now_annies = parseInt(available_now);

    BALANCE_AUDIT = parseInt(BALANCE_AUDIT) + parseInt(unconfirmed_delta);
    ANNE.USER._userNObj.balanceObj.avail_soon_annies = BALANCE_AUDIT;

    var annies_lbl = ANNE.UTILS.displayAnneValue(BALANCE_AUDIT)+"";    //round to 4 spots.
    
    if ($el_avail_now!=null) {
        $el_avail_now.innerHTML = ANNE.UTILS.displayAnneValue(available_now);
    }

    if ($el_avail_soon!=null) $el_avail_soon.innerHTML = annies_lbl;

    ANNE.A.removeClass($el_avail_soon, "balance-is-confirmed");
    ANNE.A.removeClass($el_avail_soon, "balance-is-unconfirmed");
    if (unconfirmed_delta) {
        ANNE.A.addClass($el_avail_soon, "balance-is-unconfirmed");
    }
    else ANNE.A.addClass($el_avail_soon, "balance-is-confirmed");

    if (unconfirmed_delta==0) ANNE.A.hideParent($el_avail_soon);
    else ANNE.A.showParent($el_avail_soon);

    return final_rels;
}


var DESTROY_ACCOUNT = {};
ANNEID.DESTROY_ACCOUNT = DESTROY_ACCOUNT;
DESTROY_ACCOUNT.init=function() {
    var btn_destroy_final = ANNE.A.__getEl("btn_destroy_account_final");
    btn_destroy_final.addEventListener("click", e=>DESTROY_ACCOUNT.destroyThisAcct(e));
}
DESTROY_ACCOUNT.destroyThisAcct = async()=> {
    var r = confirm("Are you sure????");
    if (r == false) {
        console.log("user exited destroy");
        return;
    }
    await USER.destroyAccount(USER._userNObj.nid);   //remove from ANNE_scope and ANNE_history
    location.reload();
}
DESTROY_ACCOUNT.destroyAll=function(){
}


var DESTROY_WALLET = {};
ANNEID.DESTROY_WALLET = DESTROY_WALLET;
DESTROY_WALLET.bINIT=false;
DESTROY_WALLET.init=function() {
    if (DESTROY_WALLET.bINIT==true) return;
    DESTROY_WALLET.bINIT=true;
    var btn_destroy = ANNE.A.__getEl("btn_destroywallet_final");
    btn_destroy.addEventListener("click", e=>DESTROY_WALLET.nukeAllDataFromBrowserMem(e));
}
DESTROY_WALLET.nukeAllDataFromBrowserMem = async()=> {
    console.warn("bye bye!");
    if (ANNE.ANNODE && typeof ANNE.ANNODE.__deleteLocalDBS==="function") {
        await ANNE.ANNODE.__deleteLocalDBS();
    }
    await ANNE.USER.nukeAllDataFromBrowserMem();
    location.reload()
}


var BACKUP = {};
ANNEID.BACKUP = BACKUP;
BACKUP.init=function(){
    BACKUP.el_btn_restore = document.getElementById("file_jsonfile");
    BACKUP.el_btn_backup = document.getElementById("btn_savebackup");
    BACKUP.el_btn_backup.addEventListener("click", function($e) {
        console.log("%c (BACKUP) clicked backup button", ANNE.TALK.bgpink);
        var history_ls = localStorage.getItem('ANNE_history');
        var anne_ls = localStorage.getItem('ANNE');
        var backup = {
            saved_by_nid:ANNE.USER._userNObj.nid,
            saved_at:new Date().getTime(),
            HISTORY_LS:JSON.parse(history_ls),
            ANNE_LS:JSON.parse(anne_ls)
        };

        //we should encrypt this with a pw. (todo)
        ANNE.UTILS.exportJSONFile(backup, ANNE.USER._userNObj.nid+"_backup");
        ANNE.USER.updateBackupFlag();
    });
    BACKUP.el_btn_restore.addEventListener("change", e=>BACKUP.restoreFromBackup(e));
}
BACKUP.restoreFromBackup=async($e)=> {
    var file = event.target.files[0];
    console.log(file);
    var reader = new FileReader();
    reader.readAsText(file,'UTF-8');
    reader.onload = readerEvent => {
        var content = readerEvent.target.result; // this is the content!
        var jsonObj = JSON.parse(content);
        console.log( jsonObj );
        var HISTORY_LS = jsonObj.HISTORY_LS;
        var ANNE_LS = jsonObj.ANNE_LS;

        //the present info in the LS will be destroyed/lost when the data wallet
        //is restored to another json set.
        var backup_history_ls = localStorage.getItem('ANNE_history');
        var backup_anne_ls = localStorage.getItem('ANNE');
        localStorage.setItem('_backup_ANNE_history', backup_history_ls);
        localStorage.setItem('_backup_ANNE', backup_anne_ls);

        //this sets 
        localStorage.setItem('ANNE_history', JSON.stringify(HISTORY_LS));
        localStorage.setItem('ANNE', JSON.stringify(ANNE_LS));
        ANNE.USER._userNObj=null;
        ANNE.USER.lockExt(null);
    }
}